/*
   Program to generate a file containing 100,000,000 bytes of integer
   GFSR data, for testing with the Marsaglia random number / Diehard
   CDROM.

   Compile as "gcc -o genigfsr genigfsr.c -lm -lrandist -L/usr/hto/lib"
*/
#include <stdio.h>

main(argc,argv)
int argc;
char **argv;
{

int i,looplim;
unsigned long l;
unsigned long igfsr();
FILE *fp,*fopen();

if (argv[1]) {  /* if a file name was given, open it for output */
   if ((fp = fopen(argv[1],"w")) == NULL) {
      fprintf(stderr,"***Error opening file %s for output.\n\n", argv[1]);
      exit(-1);
      }
   }
else {
   fprintf(stderr,"\n\nPlease use:\n\t\t%s <filename>\n\n",argv[0]);
   exit(1);
   }

looplim = 100000000 / sizeof(unsigned long);

for (i=0; i<looplim; i++) {
   l = igfsr();
   fwrite((char *)(&l), sizeof(unsigned long), 1, fp);
   }

exit(0);
}
