/* bestincol.c -- routine to find best score in a given column */
/*
   Author: Paul Hardy, U.S.C., December 1995.

   Version 1.0 release date: December 1995.
*/
#include <stdio.h>
#include "seqaln.h"

bestincol(seq1,seq2,scoring,results,io,col)
struct SEQALN_SEQUENCE *seq1,*seq2;
struct SEQALN_CONSTANTS *scoring;
struct SEQALN_RESULTS *results;
struct SEQALN_IO *io;
int col;
{
int i;

results->bestS  = results->S[0][col];
results->bestSi = 0;
results->bestSj = col;

if (scoring->mtype == SIMILARITY) { /* /looking for maximum score */
   for (i=1; i<=seq1->len; i++) {
      if (results->S[i][col] > results->bestS) {
         results->bestS  = results->S[i][col];
         results->bestSi = i;
       }
    }
 }
else {				/* looking for minimum score */
   for (i=1; i<=seq1->len; i++) {
      if (results->S[i][col] < results->bestS) {
         results->bestS  = results->S[i][col];
         results->bestSi = i;
       }
    }
 }

return;
}


