/* bestinrow.c -- routine to find best score in a given row */
/*
   Author: Paul Hardy, U.S.C., December 1995.

   Version 1.0 release date: December 1995.
*/
#include <stdio.h>
#include "seqaln.h"

bestinrow(seq1,seq2,scoring,results,io,row)
struct SEQALN_SEQUENCE *seq1,*seq2;
struct SEQALN_CONSTANTS *scoring;
struct SEQALN_RESULTS *results;
struct SEQALN_IO *io;
int row;
{
int j;

results->bestS  = results->S[row][0];
results->bestSi = row;
results->bestSj = 0;

if (scoring->mtype == SIMILARITY) { /* /looking for maximum score */
   for (j=1; j<=seq2->len; j++) {
      if (results->S[row][j] > results->bestS) {
         results->bestS  = results->S[row][j];
         results->bestSj = j;
       }
    }
 }
else {				/* looking for minimum score */
   for (j=1; j<=seq2->len; j++) {
      if (results->S[row][j] < results->bestS) {
         results->bestS  = results->S[row][j];
         results->bestSj = j;
       }
    }
 }

return;
}
