/* load_distrib.c -- routine to load a distribution frequency for p-values. */
/*
   Author: Paul Hardy, U.S.C., December 1995.

   Version 1.0 release date: December 1995.
*/
#include <stdio.h>
#include <ctype.h>
#include "seqaln.h"

int load_distrib(fn,freq,io)
char *fn;
double *freq;
struct SEQALN_IO *io;
{
FILE *fp;
int i, j;
char letter;
int length, loc;
double value;
char *mdir;
char mfn[MAXPATH+1];
char *getenv();
extern char *newmem();

  fp = fopen(fn, "r");
  if (fp == NULL) {
     (void)sprintf(mfn, "%s.dis", fn);
     fp=fopen(mfn, "r");
     if (fp==NULL) {
        mdir=getenv("MATDIR");
        if (mdir==NULL) {
           (void)fprintf(io->STDERR, "bad distribution file\n");
           exit(2);
        }
        (void)sprintf(mfn, "%s/%s", mdir, fn);
        fp=fopen(mfn, "r");
        if (fp==NULL) {
           (void)sprintf(mfn, "%s/%s.dis", mdir, fn);
           fp=fopen(mfn, "r");
           if (fp==NULL) {
              (void)fprintf(io->STDERR, "bad distribution file\n");
              exit(2);
           }  
        }
     }
  }

(void)fscanf(fp, "%d\n", &length);

while (fscanf(fp, "%c %lf\n", &letter, &value) != EOF) {
   loc = tolower((int)letter) - 'a';
   if (loc >= 0 && loc <= 25) {
      freq[loc] = value;
      }
   else {
      (void)fprintf(io->STDERR,
               "*** Illegal letter in distribution file: %c[%d]\n",
               letter,letter);
      }
   }
(void)fclose(fp);
return(length);
}
