/* load_pro.c -- routine to load a profile from a profile file. */
/*
   Author: Paul Hardy, U.S.C., December 1995.

   Version 1.0 release date: December 1995.
*/
#include <stdio.h>
#include "seqaln.h"

int load_pro(pro,scoring,io)
struct SEQALN_PROFILE *pro;
struct SEQALN_CONSTANTS *scoring;
struct SEQALN_IO *io;
{
FILE *theMatrix;
int i, j;
char c;
char *fn;
char *mdir;
char mfn[MAXPATH+1];
char *getenv();
extern char *newmem();

  fn = pro->fname;   /* Name of the profile file */
  theMatrix = fopen(fn, "r");
  if (theMatrix == NULL) {
     (void)sprintf(mfn, "%s.pro", fn);
     theMatrix=fopen(mfn, "r");
     if (theMatrix==NULL) {
        mdir=getenv("MATDIR");
        if (mdir==NULL) {
           (void)fprintf(io->STDERR, "bad profile file\n");
           exit(2);
        }
        (void)sprintf(mfn, "%s/%s", mdir, fn);
        theMatrix=fopen(mfn, "r");
        if (theMatrix==NULL) {
           (void)sprintf(mfn, "%s/%s.pro", mdir, fn);
           theMatrix=fopen(mfn, "r");
           if (theMatrix==NULL) {
              (void)fprintf(io->STDERR, "bad profile file\n");
              exit(2);
           }  
        }
     }
  }

/* Read the profile name */
for (j=0; j<MAXSEQNAME-1 && (c = fgetc(theMatrix)) != EOF && c != '\n'; j++) {
   pro->name[j] = c;
   }
pro->name[j] = '\0';  /* nullify the newline */

(void)fscanf(theMatrix, "%d%d%d",
             &pro->len, &pro->alpha, &pro->beta);
scoring->palpha = -pro->alpha;
scoring->pbeta  = -pro->beta;
pro->profile=(SEQALN_PROROW *)newmem(pro->len+1, sizeof(SEQALN_PROROW));
for (i=1; i<=pro->len; ++i) {
   for (j=0; j<26; ++j) {
      (void)fscanf(theMatrix, "%d", &pro->profile[i][j]);
      }
   }
(void)fclose(theMatrix);
return(0);
}
