/*
   make_seq.c -- module to generate a sequence of a desired length using
                 a desired frequency distribution of letters.  This only
		 sets the seq->code array, so an original sequence can
		 still be held in the seq->seq array.  Maximum sequence
		 length used is 900 letters.
*/
/*
   Author: Paul Hardy, U.S.C., December 1995.

   Version 1.0 release date: December 1995.
*/
#include <math.h>
#include <malloc.h>
#include <stdio.h>
#include "seqaln.h"

make_seq(seq)
struct SEQALN_SEQUENCE *seq;
{
  int i, j, upto;
  char *seqp;
  double sum, *freqp;
  double GFSR();
  double randval;             /* return value from GFSR() */
  char *malloc();

  if (seq->code == (char *)NULL) {
     seq->code = malloc((seq->len + 1) * sizeof(char));
   }

  seqp = seq->code;
  *seqp++ = 0;

  for (i=1; i<=seq->len; i++) {
     randval = GFSR();
     /* for (j=0, freqp=seq->freq; *freqp < randval; j++, freqp++); */
     if (randval <= seq->freq[6]) {  /* To get letters up to 'G' */
        if (randval <= seq->freq[2]) { /* To get letters 'A' and 'C' */
           j=2;
           }
        else {
           j=6;
           }
        }
     else if (randval <= seq->freq[20]) { /* To get letters up to 'U' */
        j=20;
        }
     else {
        j=25;
        }
     freqp = &seq->freq[j];
     while (j > 0 && randval <= *freqp) {
        j--;
        freqp--;
        }
     if (randval > *freqp) {
        j++;
        }
     *seqp++ = j;
   }

  return;
}
