/*
   markdiag.c -- subroutine to walk through a traceback, and mark the
                 results->aligned[][] array for every substitution location.
		 Marks these locations so the same pair of letters in two
		 sequences won't be aligned twice.
*/
/*
   Author: Paul Hardy, U.S.C., December 1995.

   Version 1.0 release date: December 1995.
*/
#include <stdio.h>
#include "seqaln.h"

markdiag(seq1,seq2,scoring,results,io)
struct SEQALN_SEQUENCE *seq1,*seq2;
struct SEQALN_CONSTANTS *scoring;
struct SEQALN_RESULTS *results;
struct SEQALN_IO *io;
{
  int i, j;
  int nexti, nextj;

  SEQALN_TRACE *ttmp;

  ttmp = results->trace;
  if (ttmp != (SEQALN_TRACE *)NULL) {
     nexti = ttmp->i;
     nextj = ttmp->j;
     if (scoring->ptype == LOCAL) {
       results->aligned[nexti][nextj] = 1;  /* local starts w/align */
     }

     ttmp = ttmp->next;
     while (ttmp != (SEQALN_TRACE *)NULL) {
        i = nexti;
	j = nextj;
	nexti = ttmp->i;
	nextj = ttmp->j;
	if ((nexti - i) == 1 && (nextj - j) == 1) { /* diag (substitution) */
	   results->aligned[nexti][nextj] = 1;
	 }
	ttmp = ttmp->next;
      }
  }
return;
}
