/*
   markdiag.c -- subroutine to walk through a traceback, and mark the
                 results->linbits[] array for every substitution location
                 in the first sequence, for tandem repeat patter declumping.
*/
/*
   Author: Paul Hardy, U.S.C., December 1995.

   Version 1.0 release date: December 1995.
*/
#include <stdio.h>
#include "seqaln.h"

markseq(seq1,seq2,scoring,results,io)
struct SEQALN_SEQUENCE *seq1,*seq2;
struct SEQALN_CONSTANTS *scoring;
struct SEQALN_RESULTS *results;
struct SEQALN_IO *io;
{
  int i, j;
  int nexti, nextj;

  SEQALN_TRACE *ttmp;

  ttmp = results->trace;
  if (ttmp != (SEQALN_TRACE *)NULL) {
     nexti = ttmp->i;
     nextj = ttmp->j;
     results->linbits[nexti] = 1;  /* local similarity starts w/align */

     ttmp = ttmp->next;
     while (ttmp != (SEQALN_TRACE *)NULL) {
        i = nexti;
	j = nextj;
	nexti = ttmp->i;
	nextj = ttmp->j;
	if (nexti != i && nextj != j) { /* diag (substitution) */
	   results->linbits[nexti] = 1;
	 }
	ttmp = ttmp->next;
      }
   }
return;
}
