/*
   memfree() -- free memory, for use after one sequence comparison in
                multiple (e.g., database) sequence comparisons.
*/
/*
   Author: Paul Hardy, U.S.C., December 1995.

   Version 1.0 release date: December 1995.
*/

#include <malloc.h>
#include "seqaln.h"

memfree(seq1,seq2,scoring,results,io)
  struct SEQALN_SEQUENCE *seq1,*seq2; /* 1st & 2nd sequences to be compared */
  struct SEQALN_CONSTANTS *scoring; /*Parameters related to scoring operation*/
  struct SEQALN_RESULTS *results;   /* Computation results. */
  struct SEQALN_IO *io;

  {

  free((char *)results->S[0]);
  free((char *)results->S);    /* Free scoring matrix. */
  if (scoring->naligns > 1 || scoring->cutoff != 0) { /* then declumping */
    free((char *)results->aligned[0]);
    free((char *)results->aligned);
  }
/*
  free(aalign);
  free(balign);
*/
  return;
}
