/* prpt_row -- function to report one profile row of scores of an alignment. */
/*
   Author: Mark Eggert, U.S.C., 1993, revised by Paul Hardy.

   Version 1.2 release date: February 1996.
*/

#include <stdio.h>
#include "seqaln.h"

void prpt_row(seq,pro,scoring,results,io,i)
struct SEQALN_SEQUENCE  *seq;
struct SEQALN_PROFILE   *pro;
struct SEQALN_CONSTANTS *scoring;
struct SEQALN_RESULTS   *results;
struct SEQALN_IO *io;
int i;
{
   int i0,j;
   static char *chf, *inf;
   static int maxS;

   if (i == 0) {  /* First time through; print header information. */
     if (scoring->memuse == LINEAR) {
       maxS = -min(pgap(pro->len,scoring),gap(seq->len,scoring));
     }
     else {
       maxS = 0;
       for (i0=0; i0<=seq->len; i0++) {
	 for (j=0; j<=pro->len; j++) {
	   if (abs(results->S[i0][j]) > maxS) {
	     maxS = abs(results->S[i0][j]);
	   }
	 }
       }
     }

     if (maxS<10) {
       chf=" %2c ";
       inf=" %2d";
     }
     else if (maxS<100) {
       chf=" %3c ";
       inf=" %3d";
     }
     else if (maxS<1000) {
       chf=" %4c ";
       inf=" %4d";
     }
     else if (maxS<10000) {
       chf=" %5c ";
       inf=" %5d";
     }
     else {
       chf=" %6c ";
       inf=" %6d";
     }
     seq->seq[0] = '-';
     (void)fprintf(io->STDOUT,"### Scoring matrix:\n ");
     /* Top row -- profile letters */
     for (j='A'; j<='Z'; j++)
        (void)fprintf(io->STDOUT,chf, j);
     (void)fprintf(io->STDOUT,"\n");
   }
   if (i >= 0 && i <= seq->len) {
      (void)fprintf(io->STDOUT," ");
      i0 = (scoring->memuse == LINEAR) ? i & 1 : i;
      for (j=0; j<=pro->len; ++j) {
	 (void)fprintf(io->STDOUT,inf, results->S[i0][j]);
         /* If already used in an alignment, mark on output */
         if (results->aligned && results->aligned[i0][j]) {
	    (void)fprintf(io->STDOUT,"'");
	 }
	 else {
	    (void)fprintf(io->STDOUT," ");
	 }
      }
      (void)fprintf(io->STDOUT,"\n");
   }
return;
}
