/*
   function to take the reverse-complement of a sequence
*/
/*
   Author: Paul Hardy, U.S.C., December 1995.

   Version 1.0 release date: December 1995.
*/

#include <stdio.h>
#include <ctype.h>
#include "seqaln.h"
#include "complement.h"

int revcomp(seq)
     struct SEQALN_SEQUENCE *seq;
{

revseq(seq);
compseq(seq);

seq->revcomp = seq->reverse && seq->complement;  /* Toggle revcomp flag */

return;
}

/*
   revseq reverses the letters in a sequence.
*/
int revseq(seq)
	struct SEQALN_SEQUENCE *seq;
{
int i,j,t;

seq->reverse = !seq->reverse; /* Toggle reverse flag */

for (i=1, j=seq->len; i<j; i++, j--) {
   t = seq->seq[i];
   seq->seq[i] = seq->seq[j];
   seq->seq[j] = t;
   t = seq->code[i];
   seq->code[i] = seq->code[j];
   seq->code[j] = t;
   }
return;
}

/*
   compseq replaces the letters in a sequence with their complement.
*/
int compseq(seq)
	struct SEQALN_SEQUENCE *seq;
{
int i;

seq->complement = !seq->complement;

for (i=1; i<=seq->len; i++) {
   seq->seq[i] = complement[seq->seq[i]];
   seq->code[i] = asc2num(seq->seq[i]);
   }

return;
}
