/*
   function to take a nucleotide sequence and translate it into a protein
   sequence
*/
/*
   Author: Paul Hardy, U.S.C., November 1996.

   Version 2.0 release date: November 1996.
*/

#include <stdio.h>
#include <ctype.h>
#include "seqaln.h"
#include "nuc2prot.h"

/* maps A->0, C->1, G->2, T->3 for xlate[] table lookup */
#define nuc_to_4(X) (X == 'A' ? 0 : (X == 'C' ? 1 : (X == 'G' ? 2 : 3)))

int xlate(seq)
     struct SEQALN_SEQUENCE *seq;
{
char c1,c2;
char *s1,*s1b,*s2; /* orig seq, orig seq translation, code sequence */
int xindex;    /* index into translation array */
int xlen;      /* length of translated string  */

s1b = s1 = &seq->seq[seq->fstart];  /* start of ORF */
s2=&seq->code[1];
xlen = 0;

while (*s1) {
   xindex = nuc_to_4(*s1++) << 4; /* Translate to 4-bit index */
   if (*s1) {
      xindex |= nuc_to_4(*s1++) << 2;
      if (*s1) {
         xindex |= nuc_to_4(*s1++);
         }
      else {
         xindex = -1;  /* ran out of characters */
         }
      }
   else {
      xindex = -1;
      }
   if (xindex >= 0) {  /* translate this codon */
      *s1b = nuc2prot[xindex];  /* declared in nuc2prot.h */
      *s2 = asc2num((int)*s1b);
      s1b++;
      s2++;
      xlen++;
      }
   }

*s1b = '\0';
*s2  = '\0';
seq->xlated = 1;  /* We translated the nucleotide sequence */
seq->len = xlen;

return;
}
